classification
Title: Interpreter can execute quickened opcodes in tracing mode
Type: behavior Stage: resolved
Components: Interpreter Core Versions: Python 3.11
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Mark.Shannon Nosy List: Mark.Shannon, kj
Priority: normal Keywords: patch

Created on 2021-07-07 14:31 by Mark.Shannon, last changed 2021-07-15 09:00 by Mark.Shannon. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 27064 merged Mark.Shannon, 2021-07-08 08:39
Messages (2)
msg397090 - (view) Author: Mark Shannon (Mark.Shannon) * (Python committer) Date: 2021-07-07 14:31
This breaks a key invariant of PEP 659.

Inserting `assert(cframe.use_tracing == 0);` at the top of all quickened instructions results in several failures when running the test suite.
msg397137 - (view) Author: Mark Shannon (Mark.Shannon) * (Python committer) Date: 2021-07-08 12:33
New changeset 514f76bbac386c320a9f3a70797241c612544391 by Mark Shannon in branch 'main':
bpo-44581: Don't execute quickened instructions if tracing is on (GH-27064)
https://github.com/python/cpython/commit/514f76bbac386c320a9f3a70797241c612544391
History
Date User Action Args
2021-07-15 09:00:50Mark.Shannonsetstatus: open -> closed
resolution: fixed
stage: patch review -> resolved
2021-07-08 12:33:25Mark.Shannonsetmessages: + msg397137
2021-07-08 08:39:39Mark.Shannonsetkeywords: + patch
stage: needs patch -> patch review
pull_requests: + pull_request25617
2021-07-07 14:31:57Mark.Shannoncreate